;||============================================================================================================================================================================||
;|| 												Antros užduoties programa. 																								   ||
;|| 						Sąlyga : Programa, kurios parametrai - failų vardai. Išveda kiekvieno failo statistinius duomenis:												   ||
;|| 						kiek buvo simbolių, kiek buvo žodžių, kiek mažųjų raidžių, kiek didžiųjų.																		   ||
;||============================================================================================================================================================================||
;|| 								Programą parašė Juljan Dzisevič informatikos II kurso studentas																			   ||
;||============================================================================================================================================================================||


.model small
.stack 100H
	
.data
 
apie    	db 'Programa skaiciuoja faile esanciu simboliu, zodziu, mazuju bei didziuju raidziu kieki.',13,10,'Ivedimo formatas :',13,10,'[ - | sourceFile1 [sourceFile2] [...] ]',13,10,13,10,'Neivedus parametru arba ivedus /? atsidarys pagalbos pranesimas',13,10,'$'
err_s    	db 'Source failo nepavyko atidaryti skaitymui',13,10,'$'
messageS    db 'Simboliu skaicius : ',13,10,'$'
messageZ    db 'Zodziu skaicius : ',13,10,'$'
messageM    db 'Mazuju raidziu skaicius : ',13,10,'$'
messageD    db 'Didziuju raidziu skaicius : ',13,10,'$'
clrf	    DB 10, 13,   '$' 					; eilutės pabaigos simbolis

sourceF   	db 12 dup (0)
sourceFHandle	dw ?
	
buffer  	db 20 dup (?)
simbolis 	db ?

simboliuS		dw 0        ;simboliu skaicius faile
simbolisP		db 0		;pries tai buves simbolis
zodziu			dw 0        ;zodziu skaicius faile
didziujuRaidziu	dw 0        ;didziuju raidziu skaicius faile
mazujuRaidziu 	dw 0        ;mazuju raidziu skaicius faile

.code

START:
	mov	ax, @data
	mov	es, ax						; es kad galetume naudot stosb funkcija: Store AL at address ES:(E)DI
 
	mov	si, 81h        				; programos paleidimo parametrai rasomi segmente es pradedant 129 (arba 81h) baitu        
 
	call	skip_spaces
	
	mov	al, byte ptr ds:[si]		; nuskaityti pirma parametro simboli
	cmp	al, 13						; jei nera parametru
	jne	_1
	jmp	help						; tai isvesti pagalba
_1:

	;; ar reikia isvesti pagalba
	mov	ax, word ptr ds:[si]
	cmp	ax, 3F2Fh        			; jei nuskaityta "/?" - 3F = '?'; 2F = '/'
	jne	_3
	jmp	help                 		; rastas "/?", vadinasi reikia isvesti pagalba
	
_3:

	;; source failo pavadinimas
	lea	di, sourceF
	call	read_filename			; perkelti is parametro i eilute
	
	push	ds
	push	si

	mov	ax, @data
	mov	ds, ax

	jmp	startConverting

readSourceFile:
	pop	si
	pop	ds

	;; source failo pavadinimas
	lea	di, sourceF
	call	read_filename			; perkelti is parametro i eilute

	push	ds
	push	si

	mov	ax, @data
	mov	ds, ax
	
	cmp	byte ptr ds:[sourceF], '$'	 ; jei nieko nenuskaite
	jne	startConverting
	jmp	closeF
	
startConverting:
	;; atidarom
	cmp	byte ptr ds:[sourceF], '$' 	; jei nieko nenuskaite
	jne	source_from_file
	
	mov	sourceFHandle, 0
	jmp	skaitom
	
source_from_file:
	mov	dx, offset sourceF			; failo pavadinimas
	mov	ah, 3dh             	   	; atidaro faila - komandos kodas
	mov	al, 0               	   	; 0 - reading, 1-writing, 2-abu
	int	21h							; INT 21h / AH= 3Dh - open existing file
	jc	testiErr					; CF set on error AX = error code.
	mov	sourceFHandle, ax			; issaugojam filehandle
	jmp skaitom
	
err_source:
	mov	ax, @data
	mov	ds, ax
	
	mov	dx, offset err_s        
	mov	ah, 09h
	int	21h

	mov	dx, offset sourceF
	int	21h
	
	mov	ax, 4c01h
	int	21h  
	
  
skaitom:
	mov	bx, sourceFHandle
	mov	dx, offset buffer   	  	; address of buffer in dx
	mov	cx, 20         				; kiek baitu nuskaitysim
	mov	ah, 3fh         			; function 3Fh - read from file
	int	21h	
		
	mov	cx, ax          			; bytes actually read
	cmp	ax, 0						; jei nenuskaite
	jne	_6							; tai ne pabaiga
	
	mov	bx, sourceFHandle			; pabaiga skaitomo failo
	mov	ah, 3eh						; uzdaryti
	int	21h	
	jmp	readSourceFile				; atidaryti kita skaitoma faila, jei yra
_6:		
	mov	si, offset buffer			; skaitoma is cia

	cmp	sourceFHandle, 0
	jne	_7
	cmp	byte ptr ds:[si], 13
	je	closeF
_7:
	push	cx						; save big loop CX
			
atrenka:		
    lodsb										; imti is es:si stringo dali ir dedame i al 
    cmp   al, ' '								; tikrinimas, ar esamasis simbolis yra tarpas. Jei taip, tai kviečiama spausdinimas, jei ne, einama prie ateinančio simbolio	
    je    tar
	cmp   al, '0'
	jb	  toliau
	cmp   al, ':'
	jb    skaicius
	cmp	  al, 'A'
	jb	  toliau
	cmp	  al, '['
	jb	  didz
	cmp   al, 'a'
	jb	  toliau
	cmp   al, '{'
	jb    maz	
	jmp   toliau
	
testiErr: 
	jmp err_source
	
toliau:		
	  
	loop	atrenka

	pop	cx
	loop	skaitom
	

help:
	mov	ax, @data
	mov	ds, ax
	
	mov	dx, offset apie         
	mov	ah, 09h
	int	21h
	jmp	_end
	
closeF:
	
    lea   dx, messageS				     			; įterpia eilutės pabaigos simbolį
    mov   ah, 09h									; persoku i kita eilute	
	mov  bx, simboliuS	
	call print
	cmp  simboliuS, 0
	jz   nulisZodziu
	add  zodziu, 1					; nes pirmo zodzio neuzskaito
nulisZodziu:
    lea   dx, messageZ				     			; įterpia eilutės pabaigos simbolį
    mov   ah, 09h									; persoku i kita eilute	
	mov  bx, zodziu	
	call print
    lea   dx, messageM				     			; įterpia eilutės pabaigos simbolį
    mov   ah, 09h									; persoku i kita eilute	
	mov  bx, mazujuRaidziu	
	call print
    lea   dx, messageD				     			; įterpia eilutės pabaigos simbolį
    mov   ah, 09h									; persoku i kita eilute	
	mov  bx, didziujuRaidziu
	call print
	
	jmp _end
	
tar:
	cmp   simbolisP, ' '
	je	  toliau
	call  tarpas
	jmp   toliau
  
skaicius:
	call  simbolisAdd
	jmp   toliau
  
maz:
	call  mazoji
	jmp   toliau
  
didz:
	call  didzioji
	jmp   toliau

_end:
	mov	ax, 4c00h
	int	21h   
	
;; procedures
print proc			
    int 21h
    xor  cx, cx										; apsisaugojam nuo šiukšlių ciklo skaitliuke
    mov ax, bx
    mov bl, 10
    simbSk:
       div   bl										; paskutiniojo skaičiaus atskirimas. Liekana keliauja į al, o sveikoji dalis į ah
       mov   dx, ax									; išsisaugojam ax reikšmę dx registre
       xor   al, al									
       xchg  ah, al									; sukeičia reikšmes vietomis
       push  ax 									; reikia ah; ah (liekana popintą steke)	
       inc   cx										; cx rodo, keliaženklis buvo skaičius
       mov   al, dl      							
       cmp   al, 0									; jei padalinus sveikoji dalis nulis - spausdint
       jz    atspausS
       jmp simbSk								; jei skaičius buvo keliaženklis, tai gaunam kitus skaitmenis
    atspausS:
       pop ax
       mov dx, ax
       add dl, 30h									; pridedama 30, nes nulio ASCII kodas = 30h, todėl po sudėties gausime dl registre gyvenusio skaičiaus ASCII kodą
       mov ah, 02h									; atspasdinimas
       int 21h										
       cmp   cx, 0									; tikrina, ar dar yra skaičių (cx parodo, keliaženklis skaičius buvo)
       jz    skpabS
           
    loop atspausS  				
   skpabS:
      lea   dx, clrf								; įterpia eilutės pabaigos simbolį
      mov   ah, 09h									; persoku i kita eilute	
      int   21h										; interuptas
       
    ret
print endp
	 
tarpas proc
	add   zodziu, 1
	ret
tarpas endp 

simbolisAdd proc
	add   simboliuS, 1
	ret
simbolisAdd endp	
  
didzioji proc
	add	  didziujuRaidziu, 1
	add	  simboliuS, 1
	ret
didzioji endp
  
mazoji proc
	add   mazujuRaidziu, 1
	add	  simboliuS, 1
	ret
mazoji endp
	
	
skip_spaces PROC near

skip_spaces_loop:
	cmp byte ptr ds:[si], ' '
	jne skip_spaces_end
	inc si
	jmp skip_spaces_loop
skip_spaces_end:
	ret
	
skip_spaces ENDP

read_filename PROC near

	push	ax
	call	skip_spaces
read_filename_start:
	cmp	byte ptr ds:[si], 13	; jei nera parametru
	je	read_filename_end	; tai taip, tai baigtas failo vedimas
	cmp	byte ptr ds:[si], ' '	; jei tarpas
	jne	read_filename_next	; tai praleisti visus tarpus, ir sokti prie kito parametro
read_filename_end:
	mov	al, '$'			; irasyti '$' gale
	stosb                           ; Store AL at address ES:(E)DI, di = di + 1
	pop	ax
	ret
read_filename_next:
	lodsb				; uzkrauna kita simboli
	stosb                           ; Store AL at address ES:(E)DI, di = di + 1
	jmp read_filename_start

read_filename ENDP
 
end START
